﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.85
@EndOfDesignText@
#Region Shared Files
#CustomBuildAction: folders ready, %WINDIR%\System32\Robocopy.exe,"..\..\Shared Files" "..\Files"
'Ctrl + click to sync files: ide://run?file=%WINDIR%\System32\Robocopy.exe&args=..\..\Shared+Files&args=..\Files&FilesSync=True
#End Region

'Ctrl + click to export as zip: ide://run?File=%B4X%\Zipper.jar&Args=Anchors2.zip

Sub Class_Globals
	Private Root As B4XView
	Private xui As XUI
	Private BBCodeView1 As BBCodeView
	Private TextEngine As BCTextEngine
	Type Area(CHANGWAT_T As String,AMPHOE_T As String,TAMBON_T As String,LATti As Long,LONGti As Long)
	Private ThaiArea As List
	Private dialog As B4XDialog
	Private SearchTemplate As B4XSearchTemplate
End Sub 

Public Sub Initialize

End Sub

'This event will be called once, before the page becomes visible.
Private Sub B4XPage_Created (Root1 As B4XView)
	Root = Root1
	Root.LoadLayout("MainPage")
	TextEngine.Initialize(Root)
	ThaiArea =LoadThaiAreaDataSet
	dialog.Initialize(Root)
	dialog.Title = "ตำแหน่งที่อยู่แต่ละตำบล"
	B4XPages.SetTitle(Me, dialog.Title)
	Sleep(400) 'let the layout load before the heavy stuff
	SearchTemplate.Initialize
	SearchTemplate.PrefixOnly = False
	Dim ChangwatNames As List
	ChangwatNames.Initialize

	For Each pol As Area In ThaiArea
		ChangwatNames.Add(pol.TAMBON_T)
	Next
	SearchTemplate.SetItems(ChangwatNames)
	
	BBCodeView1.Text = CreateBBCode
	
End Sub

Private Sub CreateBBCode As String
	'DateTime.DateFormat = "MM/dd/yyyy"
	Dim sb As StringBuilder
	sb.Initialize
	For Each pol As Area In ThaiArea
		sb.Append($"
[a="${pol.CHANGWAT_T}"][b][TextSize=18]${pol.CHANGWAT_T}[/TextSize][/b][/a]
	อำเภอ: ${pol.AMPHOE_T}
	ตำบล: ${pol.TAMBON_T}
	ละติดจูด: ${pol.LATti}
	ลองติดจูด: ${pol.LONGti}
"$)
	Next
	Return sb.ToString
End Sub


Private Sub LoadThaiAreaDataSet As List
	'DateTime.DateFormat = "yyyy-MM-dd'T'HH:mm:ssX"
	Dim su As StringUtils
	Dim res As List
	res.Initialize
	Dim data As List = su.LoadCSV(File.DirAssets, "tambon.csv", ",")
	Dim CheckForDuplicateNames As B4XSet
	CheckForDuplicateNames.Initialize
	For i = 1 To data.Size - 1 'skipping first col (0)
		Dim col() As String = data.Get(i)
		Dim changwat_t As String = col(8)
		Dim amphoe_t As String = col(5)
		Dim tambon_t As String=col(2)
		If CheckForDuplicateNames.Contains(tambon_t) Then Continue
		CheckForDuplicateNames.Add(tambon_t)
		Dim LatTi As Long =col(10)
		Dim LongTi As Long =col(11)
		res.Add(CreatePoint(tambon_t,amphoe_t,changwat_t,LatTi,LongTi))
		#if debug
		If res.Size = 500 Then Exit 'it can be a bit too slow in debug mode.
		#End If
	Next
	Return res
End Sub


Private Sub btnJumpTo_Click
	Wait For (dialog.ShowTemplate(SearchTemplate, "", "", "ยกเลิก")) Complete (result As Int)
	If result = xui.DialogResponse_Positive Then
		BBCodeView1.ScrollToAnchor(SearchTemplate.SelectedItem)
	End If
End Sub



Public Sub CreatePoint ( CHANGWAT_T As String,AMPHOE_T As String,TAMBON_T As String,LATti As Long,LONGti As Long) As Area
	Dim t1 As Area
	t1.Initialize
	t1.CHANGWAT_T = CHANGWAT_T
	t1.AMPHOE_T=AMPHOE_T
	t1.TAMBON_T=TAMBON_T
	t1.LATti=LATti
	t1.LONGti = LONGti
	
	Return t1
End Sub